/* args.c
 *
 * demonstrates the use of argc, argv, env and
 * the getenv/putenv functions
 */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<process.h>

void main(int argc, char **argv, char **env);

void main(int argc, char **argv, char **env)
    {
    int i;
    char *pathvar = "PATH",*pathstr;
    char *newpath,*newdir = "C:\\JUNK";
    char *argmessage = "PARENT=ARGS";
    char *argptr="PARENT",*argmsg;

    if((argmsg = getenv(argptr)))
        {
            /* if ARGS is already in Environment,
               parent process is probably another
               copy of us--at any rate, don't run
               another copy...just display and
               get out...
             */
        if(pathstr = getenv(pathvar))
            {
            printf("Environment of this copy of "
                    "%s includes:\n%s=%s\n%s="
                    "%s\n",argv[0],argptr,argmsg,
                    pathvar,pathstr);
            printf("Parent probably %s...",
                    argmsg);
            }   
        printf("Now returning to parent...\n");
        exit(0);
        }
    else
        printf("%s not found in environment, "
            "parent probably DOS...\n",argptr);
    
    if(argc < 2)
        printf("There are no arguments passed to "
            "%s.\n",argv[0]);
    else
        {
        printf("There are %d arguments passed to "
            "%s:\n",argc-1,argv[0]);
        for( i = 1; i < argc; i++)
            printf("argv[%02d] = %s\n",i,argv[i]);
        }

    printf("\n");

    if(!strlen(env[0]))
        printf("There are no environment"
            "variables defined.\n");
    else
        {
        printf("The environment variables "
            "consist of:\n");
        for(i = 0; env[i]; i++)
            printf("%s\n",env[i]);
        }
    /* add directory to beginning of PATH       */

        /* retrieve pathvar from environment    */
    if(pathstr = getenv(pathvar))
        printf("\n%s variable was:\n%s=%s\n\n",
            pathvar,pathvar,pathstr);

        /* create new path buffer               */
    if(newpath = malloc(strlen(pathstr)+
            strlen(pathvar)+strlen(newdir)+3))
        {
            /* copy in PATH             */
        strcpy(newpath,pathvar);
            /* add the '='              */
        strcat(newpath,"=");
            /* then the new directory   */
        strcat(newpath,newdir);
            /* and the ';'              */
        strcat(newpath,";");
            /* then the current path    */
        strcat(newpath,pathstr);
        }

        /* now put it in the environment        */
    if(!putenv(newpath))
        printf("%s variable now:\n%s=%s\n\n",
            pathvar,pathvar,getenv(pathvar));

        /* now put "PARENT=ARGS" in environment */
    if(!putenv(argmessage))
        {
        printf("%s\nplaced in environment, now "
            "attempting to run another copy of "
            "%s...\n",
             argmessage,argv[0]);
            /* run another copy of program      */
        if(spawnve(P_WAIT,argv[0],argv,env) == -1)
            printf("Unable to exec %s, "
                "errno=%d\n",
                argv[0],errno);
        printf("...returned to %s (copy that "
            "placed %s in Environment)\n",
            argv[0],argmessage);
        }
    if(newpath)
        free(newpath);
    exit(0);
    }

